﻿using Contracts;
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using System.IO;

namespace Miner
{
    class Program
    {
        static void Main(string[] args)
        {
            Host houston = new Host();
            foreach (var module in houston._modules)
            {
                Console.WriteLine("{0} {1}\n{2}", module.Name,module.Author,module.Description);
                module.Initialize();
                module.FindData();
                module.LoadData();
                module.SaveData();
            }
        }
    }

    class Host
    {
        [ImportMany(typeof(IContractModule))]
        public IEnumerable<IContractModule> _modules;

        public Host()
        {
            Bootsrap();
        }

        void Bootsrap()
        {
            AggregateCatalog catalog = new AggregateCatalog();
            string extensionPath= Path.Combine(Environment.CurrentDirectory,"Extensions");
            catalog.Catalogs.Add(new DirectoryCatalog(extensionPath));
            CompositionContainer container = new CompositionContainer(catalog);
            container.ComposeParts(this);
        }
    }
}
